//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
  deque<int> coll;

  INSERT_ELEMENTS(coll,3,7);
  INSERT_ELEMENTS(coll,2,6);
  INSERT_ELEMENTS(coll,1,5);
  PRINT_ELEMENTS(coll," :\n");

  //    
  partial_sort (coll.begin(),      //  
                coll.begin()+5,    //   
                coll.end());       //   
  PRINT_ELEMENTS(coll,"   :\n");

  //       
  partial_sort (coll.begin(),      //  
                coll.begin()+5,    //   
                coll.end(),        //   
                greater<int>());   //  
  PRINT_ELEMENTS(coll,"      :\n");

  //   
  partial_sort (coll.begin(),      //  
                coll.end(),        //   
                coll.end());       //   
  PRINT_ELEMENTS(coll,"  :\n");


  getch();
  return 0;
}

//---------------------------------------------------------------------------